    function rf_convert_for_field__serial_number()    {
// <b>Perform Script</b> [ RF Convert for Field: Serial Number;  ]

// <b>#</b> <b> Script: Repeating Fields Conversion for field: Serial Number</b>

// <b>#</b> 

// <b>#</b> <b> Requirements: This script must be run from a layout for the table containing the repeating fields.</b>

// <b>#</b> <b> Parameters: None</b>

// <b>#</b> <b> Global Fields: None</b>

// <b>#</b> <b> Post Processing: None</b>

// <b>#</b> <b> This script converts repeating field values to TAB separated values for processing by FmPro Migrator.</b>

// <b>#</b> <b> Each repeating value is concatenated together into repeating field data value [1].</b>

// <b>#</b> <b> This process works around an issue with FileMaker 7/8/9 ODBC drivers not supporting repeating fields.</b>

// <b>#</b> 

// <b>#</b> <b> Compatibility: Requires FileMaker 8 Advanced, FileMaker Pro/Advanced 9 or higher</b>

// <b>#</b> <b> 9/13/2007 - Initial Release - .com Solutions Inc.</b>

// <b>#</b> <b> 3/26/2008 - Initialized LoopCounter=1.</b>

// <b>#</b> 

// <b>Set Variable</b> [ $MaxRepeatingCount; Value: 3 ] 

// <b>Show All Records</b> 

// <b>Go to Record/Request/Page</b> 

//     [ First ]

// <b>#</b> <b> Loop thru all records on current layout</b>

// <b>Loop</b> 

// <b>Set Variable</b> [ $LoopCount; Value: 1 ] 

// <b>Set Variable</b> [ $TempRepeatingData; Value: "" ] 

// <b>Loop</b> 

// <b>#</b> <b> Loop thru all repeat values for specified field</b>

// <b>#</b> <b> Concatenate data values separated by TAB chars</b>

// <b>Set Variable</b> [ $TempRepeatingData; Value: If ( $LoopCount=1 ; tbl_Assets::Serial Number[$LoopCount] ; $TempRepeatingData & "	" & tbl_Assets::Serial Number[$LoopCount] ) ] 

// <b>Set Variable</b> [ $LoopCount; Value: $LoopCount+1 ] 

// <b>Exit Loop If</b>  [ $LoopCount &gt; $MaxRepeatingCount ] 

// <b>End Loop</b> 

// <b>#</b> <b> Put concatenated data together into Field[1] - 1st Repeat value of repeating field.</b>

// <b>Set Field</b> [ <u>tbl_Assets::Serial Number</u>; $TempRepeatingData ] 

// <b>#</b> <b> Clear temp data - before next record</b>

// <b>Set Variable</b> [ $TempRepeatingData; Value: "" ] 

// <b>Go to Record/Request/Page</b> 

//     [ Next; Exit after last ]

// <b>End Loop</b> 

    } // end of function: rf_convert_for_field__serial_number
